/*
 * Copyright (c) 2022, Shenzhen CVA Innovation CO.,LTD
 * All rights reserved.
 *
 * Shenzhen CVA Innovation CO.,LTD (CVA chip) is supplying this file for use
 * exclusively with CVA's microcontroller products. This file can be freely
 * distributed within development tools that are supporting such microcontroller
 * products.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * CVA SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 */

/*! \brief a loop memory to memory transfer
 */

/*******************************************************************************
 * the includes
 ******************************************************************************/

#include <stdint.h>
#include <string.h>
#include "mcu.h"
#include "SEGGER_RTT.h"
#include "appTask.h"
#include "canuser.h"
#include "hwctrl.h"

/*******************************************************************************
 * the defines
 ******************************************************************************/


/*******************************************************************************
 * the typedefs
 ******************************************************************************/



/*******************************************************************************
 * the globals
 ******************************************************************************/




/*******************************************************************************
 * the functions
 ******************************************************************************/


int main(void)
{
    IrqDrv_DisableGlobalInterrupt();

    hw_init();
    

    SEGGER_RTT_Init();
    SEGGER_RTT_printf(0,"app start\n");

    IrqDrv_EnableGlobalInterrupt();
    appTaskInit();

    while(1)
    {
        appTask();
    }
}
